unit CFDI33RadDelphi;

interface

uses Winapi.Windows, System.Classes, Vcl.Graphics, Vcl.Forms, Vcl.Controls,
  Vcl.Menus, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Buttons, Vcl.ExtCtrls, Vcl.ComCtrls,
  Vcl.ImgList, Vcl.StdActns, Vcl.ActnList, Vcl.ToolWin;

type
  TCFDI33 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  CFDI33: TCFDI33;

implementation

uses About;

{$R *.dfm}

{ CFDI 3.3 Simple }
procedure TCFDI33.Button1Click(Sender: TObject);
var
  i: Integer;
  hXml: LongInt;
  hBar: Thandle;

  VirtualXML_NewW                       : function  ( szVersion:PChar ): LongInt; cdecl;
  VirtualXML_SetVirtualPACInfoW         : procedure ( p:LongInt; szUser:PChar; servidor:PChar ); cdecl;
  VirtualXML_SetComprobanteInfo_cfdi33W : procedure ( p:LongInt; Serie:PChar; Folio:PChar; Fecha:PChar; FormaPago:PChar; CondicionesDePago:PChar; SubTotal:PChar; Descuento:PChar; Moneda:PChar; TipoCambio:PChar; Total:PChar; TipoDeComprobante:PChar; MetodoPago:PChar; LugarExpedicion:PChar;  Confirmacion:PChar ); cdecl;
  VirtualXML_SetCfdiRelacionados_cfdi33W: procedure ( p:LongInt; TipoRelacion:PChar ); cdecl;
  VirtualXML_AddCfdiRelacionado_cfdi33W : procedure ( p:LongInt; UUID:PChar ); cdecl;
  VirtualXML_SetReceptorInfo_cfdi33W    : procedure ( p:LongInt; Rfc:PChar; Nombre:PChar; ResidenciaFiscal:PChar; NumRegIdTrib:PChar; UsoCFDI:PChar ); cdecl;
  VirtualXML_SetEmisorInfo_cfdi33W      : procedure ( p:LongInt; Rfc:PChar; Nombre:PChar; RegimenFiscal:PChar ); cdecl;
  VirtualXML_AddConcepto_cfdi33W        : procedure ( p:LongInt; ClaveProdServ:PChar; NoIdentificacion:PChar; Cantidad:PChar; ClaveUnidad:PChar; Unidad:PChar; Descripcion:PChar; ValorUnitario:PChar; Importe:PChar; Descuento:PChar ); cdecl;
  VirtualXML_AddConceptoTraslado_cfdi33W: procedure ( p:LongInt; Base:PChar; Impuesto:PChar; TipoFactor:PChar; TasaOCuota:PChar; Importe:PChar ); cdecl;
  VirtualXML_SetImpuestosInfo_cfdi33W   : procedure ( p:LongInt; TotalImpuestosTrasladados:PChar; TotalImpuestosRetenidos:PChar ); cdecl;
  VirtualXML_AddTraslado_cfdi33W        : procedure ( p:LongInt; Impuesto:PChar; TipoFactor:PChar; TasaOCuota:PChar; Importe:PChar ); cdecl;
  VirtualXML_GetValueW                  : function  ( p:LongInt; value:LongInt ): PChar; cdecl;
  VirtualXML_ProcesaDocumentoSSLW       : function  ( p:LongInt; csd:PChar; key:PChar; keypwd:PChar; outfile:PChar ): LongInt; cdecl;
  VirtualXML_FreeW                      : procedure ( p:LongInt ); cdecl;

begin
  hBar := LoadLibrary( 'VirtualXML.dll' );

  VirtualXML_NewW                        := GetProcAddress ( Hbar, 'VirtualXML_NewW' );
  VirtualXML_SetVirtualPACInfoW          := GetProcAddress ( Hbar, 'VirtualXML_SetVirtualPACInfoW' );
  VirtualXML_SetComprobanteInfo_cfdi33W  := GetProcAddress ( Hbar, 'VirtualXML_SetComprobanteInfo_cfdi33W' );
  VirtualXML_SetCfdiRelacionados_cfdi33W := GetProcAddress ( Hbar, 'VirtualXML_SetCfdiRelacionados_cfdi33W');
  VirtualXML_AddCfdiRelacionado_cfdi33W  := GetProcAddress ( Hbar, 'VirtualXML_AddCfdiRelacionado_cfdi33W');
  VirtualXML_SetEmisorInfo_cfdi33W       := GetProcAddress ( Hbar, 'VirtualXML_SetEmisorInfo_cfdi33W' );
  VirtualXML_SetReceptorInfo_cfdi33W     := GetProcAddress ( Hbar, 'VirtualXML_SetReceptorInfo_cfdi33W' );
  VirtualXML_AddConcepto_cfdi33W         := GetProcAddress ( Hbar, 'VirtualXML_AddConcepto_cfdi33W' );
  VirtualXML_AddConceptoTraslado_cfdi33W := GetProcAddress ( Hbar, 'VirtualXML_AddConceptoTraslado_cfdi33W' );
  VirtualXML_SetImpuestosInfo_cfdi33W    := GetProcAddress ( Hbar, 'VirtualXML_SetImpuestosInfo_cfdi33W' );
  VirtualXML_AddTraslado_cfdi33W         := GetProcAddress ( Hbar, 'VirtualXML_AddTraslado_cfdi33W' );
  VirtualXML_ProcesaDocumentoSSLW        := GetProcAddress ( Hbar, 'VirtualXML_ProcesaDocumentoSSLW' );
  VirtualXML_GetValueW                   := GetProcAddress ( Hbar, 'VirtualXML_GetValueW' );
  VirtualXML_FreeW                       := GetProcAddress ( Hbar, 'VirtualXML_FreeW' );

  // paso 1. Generar el XML con las funciones de VirtualXML

  hXml := VirtualXML_NewW( '3.3');

  // Informacion de conexion a VirtualPAC requiere usuario demo de VirtualPAC
  VirtualXML_SetVirtualPacInfoW(hXml, 'demo_cibertec', 'demo');

  // Datos del comprobante
  VirtualXML_SetComprobanteInfo_cfdi33W(hXml,'A','1','%cb_date','99','Contado Comercial','1000.00','50.00','MXN','','1102.00','I','PPD','53050','');

   // Datos de documentos relacionados
   VirtualXML_SetCfdiRelacionados_cfdi33W(hXml,'04');
   VirtualXML_AddCfdiRelacionado_cfdi33W(hXml, 'FF93C8BE-AF7B-4FC5-8854-6DAE18CFB5B4');
   VirtualXML_AddCfdiRelacionado_cfdi33W(hXml, 'D8E18C2F-2859-4927-A0F0-EA3E93642DDC');
   VirtualXML_AddCfdiRelacionado_cfdi33W(hXml, 'BE1D4B47-E167-47A3-8049-70D4D43BCBE8');
   VirtualXML_AddCfdiRelacionado_cfdi33W(hXml, 'FDBA380A-9732-4FB5-A6CB-5FB4BD831697');

   // datos del emisor
   VirtualXML_SetEmisorInfo_cfdi33W(hXml,'CACX7605101P8','Persona Fisica de Prueba','612');

   // Datos del Receptor
   VirtualXML_SetReceptorInfo_cfdi33W(hXml,'CTE940531F58','Cibernetica y Tecnologa SA de CV','','','G01');

   // Concepto simple, unicamente con impuestos
   VirtualXML_AddConcepto_cfdi33W(hXml, '84111506', 'SEF500', '1', 'H87', 'Timbre', 'Paquete de 500 timbres fiscales', '500.00', '500.00', '');
   VirtualXML_AddConceptoTraslado_cfdi33W(hXml, '500.00', '002', 'Tasa', '0.160000', '80.00');

   // Concepto con descuento e impuestos
   VirtualXML_AddConcepto_cfdi33W(hXml, '84111506', 'SEF250', '2', 'H87', 'Timbre', 'Paquete de 500 timbres fiscales', '250.00', '500.00', '50.00');
   VirtualXML_AddConceptoTraslado_cfdi33W(hXml, '450.00', '002', 'Tasa', '0.160000', '72.00');

  // Informacion de Impuestos
   VirtualXML_SetImpuestosInfo_cfdi33W(hXml, '152.00', '');
   VirtualXML_AddTraslado_cfdi33W(hXml, '002', 'Tasa', '0.160000', '152.00');

  // Procesamos documento bajo es esquema de seguridad SSL
   i := VirtualXML_ProcesaDocumentoSSLW(hXml, 'CSD_CACX7605101P8.cer', 'CSD_CACX7605101P8.key', '12345678a', 'CFDI33Basico.xml');

  if VirtualXML_GetValueW(hXml, 1) = 'VIRTUALXML_OK' then
  begin

      application.MessageBox(VirtualXML_GetValueW( hXML, 3),'No. de certificado del emisor' );
      application.MessageBox(VirtualXML_GetValueW( hXML, 4),'Sello digital del emisor');
      application.MessageBox(VirtualXML_GetValueW( hXML, 5),'Cadena original del documento');
      application.MessageBox(VirtualXML_GetValueW( hXML, 6),'No. de certificado del SAT');
      application.MessageBox(VirtualXML_GetValueW( hXML, 7),'Sello digital del timbre');
      application.MessageBox(VirtualXML_GetValueW( hXML, 8),'Cadena original del timbre');
      application.MessageBox(VirtualXML_GetValueW( hXML, 9),'UUID Folio fiscal');
      application.MessageBox(VirtualXML_GetValueW( hXML, 10),'Fecha de generacion del timbre');
      application.MessageBox(VirtualXML_GetValueW( hXML, 11),'Fecha de inicio de vigencia del certificado');
      application.MessageBox(VirtualXML_GetValueW( hXML, 12),'Fecha de terminacion de vigencia del certificado');
      application.MessageBox(VirtualXML_GetValueW( hXML, 13),'ID de operacion VirtualPAC');
      application.MessageBox(VirtualXML_GetValueW( hXML, 14),'Cantidad de timbres disponbiles');
      application.MessageBox(VirtualXML_GetValueW( hXML, 15),'Version de la libreria');
      application.MessageBox(VirtualXML_GetValueW( hXML, 16),'Fecha de emision del XML');
      application.MessageBox(VirtualXML_GetValueW( hXML, 17),'Mensaje del PAC');
      application.MessageBox(VirtualXML_GetValueW( hXML, 18),'PAC que certifico el documento');
      application.MessageBox(VirtualXML_GetValueW( hXML, 19),'No. de revision de la libreria');
      application.MessageBox(VirtualXML_GetValueW( hXML, 20),'RFC del proveedor de certificacion');
      application.MessageBox(VirtualXML_GetValueW( hXML, 21),'Leyenda del PAC');
    end
    else
      application.MessageBox(VirtualXML_GetValueW( hXML, 2),'Descripcion del error');

    VirtualXML_FreeW(hXML);

  FreeLibrary(Hbar);

end;

{ CFDI 3.3.con Complemento de Pagos 1.0 }
procedure TCFDI33.Button2Click(Sender: TObject);
var
   i: Integer;
  hXml: LongInt;
  hBar: Thandle;

  VirtualXML_NewW                           : function  ( szVersion:PChar ): LongInt; cdecl;
  VirtualXML_SetVirtualPACInfoW             : procedure ( p:LongInt; szUser:PChar; servidor:PChar ); cdecl;
  VirtualXML_SetComprobanteInfo_cfdi33W     : procedure ( p:LongInt; Serie:PChar; Folio:PChar; Fecha:PChar; FormaPago:PChar; CondicionesDePago:PChar; SubTotal:PChar; Descuento:PChar; Moneda:PChar; TipoCambio:PChar; Total:PChar; TipoDeComprobante:PChar; MetodoPago:PChar; LugarExpedicion:PChar;  Confirmacion:PChar ); cdecl;
  VirtualXML_SetReceptorInfo_cfdi33W        : procedure ( p:LongInt; Rfc:PChar; Nombre:PChar; ResidenciaFiscal:PChar; NumRegIdTrib:PChar; UsoCFDI:PChar ); cdecl;
  VirtualXML_SetEmisorInfo_cfdi33W          : procedure ( p:LongInt; Rfc:PChar; Nombre:PChar; RegimenFiscal:PChar ); cdecl;
  VirtualXML_AddConcepto_cfdi33W            : procedure ( p:LongInt; ClaveProdServ:PChar; NoIdentificacion:PChar; Cantidad:PChar; ClaveUnidad:PChar; Unidad:PChar; Descripcion:PChar; ValorUnitario:PChar; Importe:PChar; Descuento:PChar ); cdecl;
  VirtualXML_SetPagos10W                    : procedure ( p:LongInt ); cdecl ;
  VirtualXML_Pagos10SetPagoW                : procedure ( p:LongInt; FechaPago:PChar; FormaDePago:PChar; MonedaP:PChar; TipoCambioP:PChar; Monto:PChar; NumOperacion:PChar; RfcEmisorCtaOrd:PChar; NomBancoOrdExt:PChar; CtaOrdenante:PChar; RfcEmisorCtaBen:PChar; CtaBeneficiario:PChar; TipoCadPago:PChar; CertPago:PChar;  CadPago:PChar; SelloPago:PChar ); cdecl;
  VirtualXML_Pagos10AddPagoDoctoRelacionadoW: procedure ( p:LongInt; IdDocumento:PChar; Serie:PChar; Folio:PChar; MonedaDR:PChar; TipoCambioDR:PChar; MetodoDePagoDR:PChar; NumParcialidad:PChar; ImpSaldoAnt:PChar; ImpPagado:PChar; ImpSaldoInsoluto:PChar ); cdecl;
  VirtualXML_ProcesaDocumentoW              : function  ( p:LongInt; csd:PChar; key:PChar; keypwd:PChar; outfile:PChar ): LongInt; cdecl;
  VirtualXML_GetValueW                      : function  ( p:LongInt; value:LongInt ): PChar; cdecl;
  VirtualXML_FreeW                          : procedure ( p:LongInt ); cdecl;

begin

   Hbar := LoadLibrary( 'VirtualXML.dll' );

  VirtualXML_NewW                            := GetProcAddress ( Hbar, 'VirtualXML_NewW' );
  VirtualXML_SetVirtualPACInfoW              := GetProcAddress ( Hbar, 'VirtualXML_SetVirtualPACInfoW' );
  VirtualXML_SetComprobanteInfo_cfdi33W      := GetProcAddress ( Hbar, 'VirtualXML_SetComprobanteInfo_cfdi33W' );
  VirtualXML_SetEmisorInfo_cfdi33W           := GetProcAddress ( Hbar, 'VirtualXML_SetEmisorInfo_cfdi33W' );
  VirtualXML_SetReceptorInfo_cfdi33W         := GetProcAddress ( Hbar, 'VirtualXML_SetReceptorInfo_cfdi33W' );
  VirtualXML_AddConcepto_cfdi33W             := GetProcAddress ( Hbar, 'VirtualXML_AddConcepto_cfdi33W' );
  VirtualXML_SetPagos10W                     := GetProcAddress ( Hbar, 'VirtualXML_SetPagos10W');
  VirtualXML_Pagos10SetPagoW                 := GetProcAddress ( Hbar, 'VirtualXML_Pagos10SetPagoW' );
  VirtualXML_Pagos10AddPagoDoctoRelacionadoW := GetProcAddress ( Hbar, 'VirtualXML_Pagos10AddPagoDoctoRelacionadoW' );
  VirtualXML_ProcesaDocumentoW               := GetProcAddress ( Hbar, 'VirtualXML_ProcesaDocumentoSSLW' );
  VirtualXML_GetValueW                       := GetProcAddress ( Hbar, 'VirtualXML_GetValueW' );
  VirtualXML_FreeW                           := GetProcAddress ( Hbar, 'VirtualXML_FreeW' );

   hXml := VirtualXMl_NewW('3.3');

   VirtualXML_SetVirtualPacInfoW(hXml,'demo_cibertec','demo');

   VirtualXML_SetComprobanteInfo_cfdi33W(hXml,'PAGO','1','%cb_date','','','0','','XXX','','0','P','','53050','');

   VirtualXML_SetEmisorInfo_cfdi33W(hXml,'KIJ0906199R1','Empresa de prueba SA de CV','601');

   VirtualXML_SetReceptorInfo_cfdi33W(hXml,'CTE940531F58','Cibernetica y Tecnologa SA de CV','','','P01');

   VirtualXML_AddConcepto_cfdi33W(hXml, '84111506', '', '1', 'ACT', '', 'Pago', '0', '0', '');

   VirtualXML_SetPagos10W(hXml);

   VirtualXML_Pagos10SetPagoW(hXml,'2017-05-31T12:00:00','02','MXN','','1160.00','652','BSM970519DU8','','002180065145757870','CFA950629CAA','002180065145895321','','','','');

   VirtualXML_Pagos10AddPagoDoctoRelacionadoW(hXml,'FF93C8BE-AF7B-4FC5-8854-6DAE18CFB5B4','A','434','MXN','','PPD','1','1160.00','1160.00','0.00');

   i := VirtualXML_ProcesaDocumentoW(hXml,'CSD_KIJ0906199R1.cer','CSD_KIJ0906199R1.key','12345678a','EjemploCFDI33conPagos10.xml');

   if VirtualXML_GetValueW(hXml, 1) = 'VIRTUALXML_OK' then
    begin

      application.MessageBox(VirtualXML_GetValueW( hXML, 3),'No. de certificado del emisor' );
      application.MessageBox(VirtualXML_GetValueW( hXML, 4),'Sello digital del emisor');
      application.MessageBox(VirtualXML_GetValueW( hXML, 5),'Cadena original del documento');
      application.MessageBox(VirtualXML_GetValueW( hXML, 6),'No. de certificado del SAT');
      application.MessageBox(VirtualXML_GetValueW( hXML, 7),'Sello digital del timbre');
      application.MessageBox(VirtualXML_GetValueW( hXML, 8),'Cadena original del timbre');
      application.MessageBox(VirtualXML_GetValueW( hXML, 9),'UUID Folio fiscal');
      application.MessageBox(VirtualXML_GetValueW( hXML, 10),'Fecha de generacion del timbre');
      application.MessageBox(VirtualXML_GetValueW( hXML, 11),'Fecha de inicio de vigencia del certificado');
      application.MessageBox(VirtualXML_GetValueW( hXML, 12),'Fecha de terminacion de vigencia del certificado');
      application.MessageBox(VirtualXML_GetValueW( hXML, 13),'ID de operacion VirtualPAC');
      application.MessageBox(VirtualXML_GetValueW( hXML, 14),'Cantidad de timbres disponbiles');
      application.MessageBox(VirtualXML_GetValueW( hXML, 15),'Version de la libreria');
      application.MessageBox(VirtualXML_GetValueW( hXML, 16),'Fecha de emision del XML');
      application.MessageBox(VirtualXML_GetValueW( hXML, 17),'Mensaje del PAC');
      application.MessageBox(VirtualXML_GetValueW( hXML, 18),'PAC que certifico el documento');
      application.MessageBox(VirtualXML_GetValueW( hXML, 19),'No. de revision de la libreria');
      application.MessageBox(VirtualXML_GetValueW( hXML, 20),'RFC del proveedor de certificacion');
      application.MessageBox(VirtualXML_GetValueW( hXML, 21),'Leyenda del PAC');
    end
    else
      application.MessageBox(VirtualXML_GetValueW( hXML, 2),'Descripcion del error');

    VirtualXML_FreeW(hXML);

  FreeLibrary(Hbar);


end;

{ CFDI 3.3 Con complemento de Nomina 1.2 }
procedure TCFDI33.Button3Click(Sender: TObject);
var
  i: Integer;
  hXml: LongInt;
  hBar: Thandle;

  VirtualXML_NewW                           : function  ( szVersion:PChar ): LongInt; cdecl;
  VirtualXML_SetVirtualPACInfoW             : procedure ( p:LongInt; szUser:PChar; servidor:PChar ); cdecl;
  VirtualXML_SetComprobanteInfo_cfdi33W     : procedure ( p:LongInt; Serie:PChar; Folio:PChar; Fecha:PChar; FormaPago:PChar; CondicionesDePago:PChar; SubTotal:PChar; Descuento:PChar; Moneda:PChar; TipoCambio:PChar; Total:PChar; TipoDeComprobante:PChar; MetodoPago:PChar; LugarExpedicion:PChar;  Confirmacion:PChar ); cdecl;
  VirtualXML_SetReceptorInfo_cfdi33W        : procedure ( p:LongInt; Rfc:PChar; Nombre:PChar; ResidenciaFiscal:PChar; NumRegIdTrib:PChar; UsoCFDI:PChar ); cdecl;
  VirtualXML_SetEmisorInfo_cfdi33W          : procedure ( p:LongInt; Rfc:PChar; Nombre:PChar; RegimenFiscal:PChar ); cdecl;
  VirtualXML_AddConcepto_cfdi33W            : procedure ( p:LongInt; ClaveProdServ:PChar; NoIdentificacion:PChar; Cantidad:PChar; ClaveUnidad:PChar; Unidad:PChar; Descripcion:PChar; ValorUnitario:PChar; Importe:PChar; Descuento:PChar ); cdecl;
  VirtualXML_SetNomina12W                   : procedure ( p:LongInt; TipoNomina:PChar; FechaPago:PChar; FechaInicialPago:PChar; FechaFinalPago:PChar; NumDiasPagados:PChar; TotalPercepciones:PChar; TotalDeducciones:PChar; TotalOtrosPagos:PChar ); cdecl;
  VirtualXML_Nomina12SetEmisorW             : procedure ( p:LongInt; Curp:PChar; RegistroPatronal:PChar; RfcPatronOrigen:PChar; OrigenRecurso:PChar; MontoRecursoPropio :PChar ); cdecl;
  VirtualXML_Nomina12SetReceptorW           : procedure ( p:LongInt; Curp:PChar; NumSeguridadSocial:PChar; FechaInicioRelLaboral:PChar; Antiguedad:PChar; TipoContrato:PChar; Sindicalizado:PChar; TipoJornada:PChar; TipoRegimen:PChar; NumEmpleado:PChar; Departamento:PChar; Puesto:PChar; RiesgoPuesto:PChar; PeriodicidadPago:PChar; Banco:PChar; CuentaBancaria:PChar; SalarioBaseCotApor:PChar;  SalarioDiarioIntegrado:PChar;  ClaveEntFed:PChar ); cdecl;
  VirtualXML_Nomina12SetPercepcionesW       : procedure ( p:LongInt; TotalSueldos:PChar; TotalSeparacionIndemnizacion:PChar; TotalJubilacionPensionRetiro:PChar; TotalGravado:PChar; TotalExento:PChar ); cdecl;
  VirtualXML_Nomina12AddPercepcionW         : procedure ( p:LongInt; TipoPercepcion:PChar; Clave:PChar; Concepto:PChar; ImporteGravado:PChar; ImporteExento:PChar; Dias:PChar; TipoHoras:PChar; HorasExtra:PChar; ImportePagado:PChar; ValorMercado:PChar; PrecioAlOtorgarse:PChar ); cdecl;
  VirtualXML_Nomina12SetDeduccionesW        : procedure ( p:LongInt; TotalOtrasDeducciones:PChar; TotalImpuestosRetenidos:PChar ); cdecl;
  VirtualXML_Nomina12AddDeduccionW          : procedure ( p:LongInt; TipoDeduccion:PChar; Clave:PChar; Concepto:PChar; Importe:PChar ); cdecl;
  VirtualXML_Nomina12AddOtroPagoW           : procedure ( p:LongInt; TipoOtroPago:PChar; Clave:PChar; Concepto:PChar; Importe:PChar; SaldoAFavor:PChar; Anio:PChar; RemanenteSalFav:PChar; SubsidioCausado:PChar ); cdecl;
  VirtualXML_ProcesaDocumentoW              : function  ( p:LongInt; csd:PChar; key:PChar; keypwd:PChar; outfile:PChar ): LongInt; cdecl;
  VirtualXML_GetValueW                      : function  ( p:LongInt; value:LongInt ): PChar; cdecl;
  VirtualXML_FreeW                          : procedure ( p:LongInt ); cdecl;


begin
  Hbar := LoadLibrary( 'VirtualXML.dll' );

  VirtualXML_NewW                       := GetProcAddress ( Hbar, 'VirtualXML_NewW' );
  VirtualXML_SetVirtualPACInfoW         := GetProcAddress ( Hbar, 'VirtualXML_SetVirtualPACInfoW' );
  VirtualXML_SetComprobanteInfo_cfdi33W := GetProcAddress ( Hbar, 'VirtualXML_SetComprobanteInfo_cfdi33W' );
  VirtualXML_SetEmisorInfo_cfdi33W      := GetProcAddress ( Hbar, 'VirtualXML_SetEmisorInfo_cfdi33W' );
  VirtualXML_SetReceptorInfo_cfdi33W    := GetProcAddress ( Hbar, 'VirtualXML_SetReceptorInfo_cfdi33W' );
  VirtualXML_AddConcepto_cfdi33W        := GetProcAddress ( Hbar, 'VirtualXML_AddConcepto_cfdi33W' );
  VirtualXML_SetNomina12W               := GetProcAddress ( Hbar, 'VirtualXML_SetNomina12W' );
  VirtualXML_Nomina12SetEmisorW         := GetProcAddress ( Hbar, 'VirtualXML_Nomina12SetEmisorW' );
  VirtualXML_Nomina12SetReceptorW       := GetProcAddress ( Hbar, 'VirtualXML_Nomina12SetReceptorW' );
  VirtualXML_Nomina12SetPercepcionesW   := GetProcAddress ( Hbar, 'VirtualXML_Nomina12SetPercepcionesW' );
  VirtualXML_Nomina12AddPercepcionW     := GetProcAddress ( Hbar, 'VirtualXML_Nomina12AddPercepcionW' );
  VirtualXML_Nomina12SetDeduccionesW    := GetProcAddress ( Hbar, 'VirtualXML_Nomina12SetDeduccionesW' );
  VirtualXML_Nomina12AddDeduccionW      := GetProcAddress ( Hbar, 'VirtualXML_Nomina12AddDeduccionW' );
  VirtualXML_Nomina12AddOtroPagoW       := GetProcAddress ( Hbar, 'VirtualXML_Nomina12AddOtroPagoW' );
  VirtualXML_ProcesaDocumentoW          := GetProcAddress ( Hbar, 'VirtualXML_ProcesaDocumentoSSLW' );
  VirtualXML_GetValueW                  := GetProcAddress ( Hbar, 'VirtualXML_GetValueW' );
  VirtualXML_FreeW                      := GetProcAddress ( Hbar, 'VirtualXML_FreeW' );

   hXml := VirtualXML_NewW('3.3');

   VirtualXML_SetVirtualPacInfoW(hXml,'demo_cibertec','cibertec');

   VirtualXML_SetComprobanteInfo_cfdi33W(hXml,'NOM','1233','%cb_date','99','','1652.00','123.00','MXN','','1529.00','N','PUE','53050','');

   VirtualXML_SetEmisorInfo_cfdi33W(hXml,'KIJ0906199R1','Prueba de Nomina 12 con CFDI 33 SA de CV','601');
   VirtualXML_SetReceptorInfo_cfdi33W(hXml,'MADM700211HE3','MARQUEZ DELGADO MIGUEL ANGEL','','','P01');

   VirtualXML_AddConcepto_cfdi33W(hXml,'84111505','','1','ACT','','Pago de nmina','1652.00','1652.00','123.00');


   VirtualXML_SetNomina12W(hXml,'O','2017-01-20','2017-01-16','2017-01-22','7','1652.00','123.00','');
   VirtualXML_Nomina12SetEmisorW(hXml,'','C3910341106','','','');
   VirtualXML_Nomina12SetReceptorW(hXml,'MADM700211HDFRLG08','11007002493','2005-10-31','P586W','01','','04','02','1003','PAILERIA','AYUDANTE GENERAL','4','02','002','5256781005252593','','248.28','MEX');
   VirtualXML_Nomina12SetPercepcionesW(hXml,'1652.00','','','1652.00','0.00');

   VirtualXML_Nomina12AddPercepcionW(hXml, '001', '101', 'SUELDO', '1652.00', '0.00', '', '', '', '', '', '');
   VirtualXML_Nomina12SetDeduccionesW(hXml,'42.00','81.00');
   VirtualXML_Nomina12AddDeduccionW(hXml,'002','201','ISR SALARIOS','81.00');
   VirtualXML_Nomina12AddDeduccionW(hXml,'001','202','IMSS','42.00');

   VirtualXML_Nomina12AddOtroPagoW(hXml,'002','SubEmp','Subsidio al empleo','0.00','','','','0.00');

    i := VirtualXML_ProcesaDocumentoW(hXml,'CSD_KIJ0906199R1.cer','CSD_KIJ0906199R1.key','12345678a','EjemploCFDI33conNomina12.xml');

   if VirtualXML_GetValueW(hXml, 1) = 'VIRTUALXML_OK' then
    begin

      application.MessageBox(VirtualXML_GetValueW( hXML, 3),'No. de certificado del emisor' );
      application.MessageBox(VirtualXML_GetValueW( hXML, 4),'Sello digital del emisor');
      application.MessageBox(VirtualXML_GetValueW( hXML, 5),'Cadena original del documento');
      application.MessageBox(VirtualXML_GetValueW( hXML, 6),'No. de certificado del SAT');
      application.MessageBox(VirtualXML_GetValueW( hXML, 7),'Sello digital del timbre');
      application.MessageBox(VirtualXML_GetValueW( hXML, 8),'Cadena original del timbre');
      application.MessageBox(VirtualXML_GetValueW( hXML, 9),'UUID Folio fiscal');
      application.MessageBox(VirtualXML_GetValueW( hXML, 10),'Fecha de generacion del timbre');
      application.MessageBox(VirtualXML_GetValueW( hXML, 11),'Fecha de inicio de vigencia del certificado');
      application.MessageBox(VirtualXML_GetValueW( hXML, 12),'Fecha de terminacion de vigencia del certificado');
      application.MessageBox(VirtualXML_GetValueW( hXML, 13),'ID de operacion VirtualPAC');
      application.MessageBox(VirtualXML_GetValueW( hXML, 14),'Cantidad de timbres disponbiles');
      application.MessageBox(VirtualXML_GetValueW( hXML, 15),'Version de la libreria');
      application.MessageBox(VirtualXML_GetValueW( hXML, 16),'Fecha de emision del XML');
      application.MessageBox(VirtualXML_GetValueW( hXML, 17),'Mensaje del PAC');
      application.MessageBox(VirtualXML_GetValueW( hXML, 18),'PAC que certifico el documento');
      application.MessageBox(VirtualXML_GetValueW( hXML, 19),'No. de revision de la libreria');
      application.MessageBox(VirtualXML_GetValueW( hXML, 20),'RFC del proveedor de certificacion');
      application.MessageBox(VirtualXML_GetValueW( hXML, 21),'Leyenda del PAC');
    end
    else
      application.MessageBox(VirtualXML_GetValueW( hXML, 2),'Descripcion del error');

    VirtualXML_FreeW(hXML);

  FreeLibrary(Hbar);
end;

{ Timbrado de CFDI 3.3 desde un XML creado externamente }
procedure TCFDI33.Button4Click(Sender: TObject);
var
  i: Integer;
  hXml: LongInt;
  hBar: Thandle;

  VirtualXML_NewW                   : function  ( szVersion:PChar ): LongInt; cdecl;
  VirtualXML_SetVirtualPACInfoW     : procedure ( p:LongInt; szUser:PChar; servidor:PChar ); cdecl;
  VirtualXML_SetCompleteXML_cfdi33W : procedure ( p:LongInt; XMLCompleto:PChar ); cdecl;
  VirtualXML_GetValueW              : function  ( p:LongInt; value:LongInt ): PChar; cdecl;
  VirtualXML_ProcesaDocumentoW      : function  ( p:LongInt; csd:PChar; key:PChar; keypwd:PChar; outfile:PChar ): LongInt; cdecl;
  VirtualXML_FreeW                  : procedure ( p:LongInt ); cdecl;


  begin

  hBar := LoadLibrary( 'VirtualXML.dll' );

  VirtualXML_NewW                   := GetProcAddress ( hBar, 'VirtualXML_NewW' );
  VirtualXML_SetVirtualPACInfoW     := GetProcAddress ( hBar, 'VirtualXML_SetVirtualPACInfoW' );
  VirtualXML_SetCompleteXML_cfdi33W := GetProcAddress ( hBar, 'VirtualXML_SetCompleteXML_cfdi33W' );
  VirtualXML_GetValueW              := GetProcAddress ( hBar, 'VirtualXML_GetValueW' );
  VirtualXML_ProcesaDocumentoW      := GetProcAddress ( hBar, 'VirtualXML_ProcesaDocumentoW' );
  VirtualXML_FreeW                  := GetProcAddress ( hBar, 'VirtualXML_FreeW' );

   hXml := VirtualXML_NewW('3.3');

   VirtualXML_SetVirtualPacInfoW(hXml,'demo_cibertec','cibertec');

   VirtualXML_SetCompleteXML_cfdi33W(hXml, 'ejemploexterno.xml');

   i := VirtualXML_ProcesaDocumentoW(hXml,'CSD_CACX7605101P8.cer','CSD_CACX7605101P8.key','12345678a','CFDI33Externo.xml');

    if VirtualXML_GetValueW(hXml, 1) = 'VIRTUALXML_OK' then

    begin

      application.MessageBox(VirtualXML_GetValueW( hXML, 3),'No. de certificado del emisor' );
      application.MessageBox(VirtualXML_GetValueW( hXML, 4),'Sello digital del emisor');
      application.MessageBox(VirtualXML_GetValueW( hXML, 5),'Cadena original del documento');
      application.MessageBox(VirtualXML_GetValueW( hXML, 6),'No. de certificado del SAT');
      application.MessageBox(VirtualXML_GetValueW( hXML, 7),'Sello digital del timbre');
      application.MessageBox(VirtualXML_GetValueW( hXML, 8),'Cadena original del timbre');
      application.MessageBox(VirtualXML_GetValueW( hXML, 9),'UUID Folio fiscal');
      application.MessageBox(VirtualXML_GetValueW( hXML, 10),'Fecha de generacion del timbre');
      application.MessageBox(VirtualXML_GetValueW( hXML, 11),'Fecha de inicio de vigencia del certificado');
      application.MessageBox(VirtualXML_GetValueW( hXML, 12),'Fecha de terminacion de vigencia del certificado');
      application.MessageBox(VirtualXML_GetValueW( hXML, 13),'ID de operacion VirtualPAC');
      application.MessageBox(VirtualXML_GetValueW( hXML, 14),'Cantidad de timbres disponbiles');
      application.MessageBox(VirtualXML_GetValueW( hXML, 15),'Version de la libreria');
      application.MessageBox(VirtualXML_GetValueW( hXML, 16),'Fecha de emision del XML');
      application.MessageBox(VirtualXML_GetValueW( hXML, 17),'Mensaje del PAC');
      application.MessageBox(VirtualXML_GetValueW( hXML, 18),'PAC que certifico el documento');
      application.MessageBox(VirtualXML_GetValueW( hXML, 19),'No. de revision de la libreria');
      application.MessageBox(VirtualXML_GetValueW( hXML, 20),'RFC del proveedor de certificacion');
      application.MessageBox(VirtualXML_GetValueW( hXML, 21),'Leyenda del PAC');
    end
    else
      application.MessageBox(VirtualXML_GetValueW( hXML, 2),'Descripcion del error');

    VirtualXML_FreeW(hXML);

  FreeLibrary(Hbar);

end;

{ Cancelacion de CFDI bajo el Nuevo esquema }
procedure TCFDI33.Button5Click(Sender: TObject);
var
  i: Integer;
  hXml: LongInt;
  hBar: Thandle;
  cIni: TextFile;
  cLog: TextFile;
  VirtualXML_CancelaCFDIW : function( szUsuario:PChar; szRfcEmisor:PChar; szRfcReceptor:PChar; szTotal:PChar; szUuid:PChar; sZCert:PChar; szKey:PChar; szPwd:PChar; szResult:PChar; szLog:PChar ): LongInt; cdecl;

  begin

    Hbar := LoadLibrary( 'VirtualXML.dll' );
    VirtualXML_CancelaCFDIW := GetProcAddress( Hbar, 'VirtualXML_CancelaCFDIW' );
    i := VirtualXML_CancelaCFDIW('demo_cibertec','AAA010101AAA', 'XAXX010101000', '115.43','F94FE4AC-4743-4745-BA99-E0D13100331D','.\AAA010101AAA.CER', '.\AAA010101AAA.KEY','12345678a','CancelaCFDI.INI','CancelaCFDI.LOG');
    case i of
      1 : application.MessageBox('CFDI Cancelable con autorizacin','Resultado');
      0 : application.MessageBox('CFDI Cancelado directamente','Resultado');
      -1 : application.MessageBox('CFDI NO es cancelable','Resultado');
      -2 : application.MessageBox('CFDI No encontrado','Resultado');
      -3 : application.MessageBox('Error interno de cancelacin, revise la bitcora','Resultado');
    end;
    //Memo.Lines.LoadFromFile();
     AssignFile(cIni,'CancelaCFDI.INI');
     AssignFile(cLog,'CancelaCFDI.LOG');

  end;


{CFDI 3.3 con Complemento de Carta Porte}
procedure TCFDI33.Button7Click(Sender: TObject);

var
  i: Integer;
  hXml: LongInt;
  hBar: Thandle;

  VirtualXML_NewW                                           : function  ( szVersion:PChar ): LongInt; cdecl;
  VirtualXML_SetVirtualPACInfoW                             : procedure ( p:LongInt; szUser:PChar; servidor:PChar ); cdecl;
  VirtualXML_SetComprobanteInfo_cfdi33W                     : procedure ( p:LongInt; Serie:PChar; Folio:PChar; Fecha:PChar; FormaPago:PChar; CondicionesDePago:PChar; SubTotal:PChar; Descuento:PChar; Moneda:PChar; TipoCambio:PChar; Total:PChar; TipoDeComprobante:PChar; MetodoPago:PChar; LugarExpedicion:PChar;  Confirmacion:PChar ); cdecl;
  VirtualXML_SetReceptorInfo_cfdi33W                        : procedure ( p:LongInt; Rfc:PChar; Nombre:PChar; ResidenciaFiscal:PChar; NumRegIdTrib:PChar; UsoCFDI:PChar ); cdecl;
  VirtualXML_SetEmisorInfo_cfdi33W                          : procedure ( p:LongInt; Rfc:PChar; Nombre:PChar; RegimenFiscal:PChar ); cdecl;
  VirtualXML_AddConcepto_cfdi33W                            : procedure ( p:LongInt; ClaveProdServ:PChar; NoIdentificacion:PChar; Cantidad:PChar; ClaveUnidad:PChar; Unidad:PChar; Descripcion:PChar; ValorUnitario:PChar; Importe:PChar; Descuento:PChar ); cdecl;
  VirtualXML_SetCartaPorte10W                               : procedure ( p:LongInt; TranspInternac:PChar; EntradaSalidaMerc:PChar; ViaEntradaSalida:PChar; TotalDistRec:PChar ); cdecl;
  VirtualXML_CartaPorte10AddUbicacionW                      : procedure ( p:LongInt; TipoEstacion:PChar; DistanciaRecorrida:PChar; IDOrigen:PChar; RFCRemitente:PChar; NombreRemitente:PChar; OrigenNumRegIdTrib:PChar; OrigenResidenciaFiscal:PChar; OrigenNumEstacion:PChar; OrigenNombreEstacion:PChar; OrigenNavegacionTrafico:PChar; FechaHoraSalida:PChar; IDDestino:PChar; RFCDestinatario:PChar;  NombreDestinatario:PChar;  DestinoNumRegIdTrib:PChar;  DestinoResidenciaFiscal:PChar;  DestinoNumEstacion        :PChar;  DestinoNombreEstacion:PChar;  DestinoNavegacionTrafico:PChar;  FechaHoraProgLlegada:PChar;  Calle         :PChar;  NumeroExterior     :PChar;  NumeroInterior:PChar;  Colonia    :PChar;   Localidad:PChar; Referencia:PChar; 	Municipio:PChar;  Estado:PChar;  Pais:PChar;  CodigoPostal:PChar ); cdecl;
  VirtualXML_CartaPorte10SetMercanciasW                     : procedure ( p:LongInt; PesoBrutoTotal:PChar; UnidadPeso:PChar; PesoNetoTotal:PChar; NumTotalMercancias:PChar; CargoPorTasacion:PChar ); cdecl;
  VirtualXML_CartaPorte10AddMercanciaW                      : procedure ( p:LongInt; BienesTransp:PChar; ClaveSTCC:PChar; Descripcion:PChar; Cantidad:PChar; ClaveUnidad:PChar; Unidad:PChar; Dimensiones:PChar; MaterialPeligroso:PChar; CveMaterialPeligroso:PChar; Embalaje:PChar; DescripEmbalaje:PChar; PesoEnKg:PChar; ValorMercancia:PChar; Moneda:PChar;  FraccionArancelaria   :PChar;  UUIDComercioExt        :PChar;  CantidadTransportaCantidad:PChar;  IDOrigen             :PChar;  IDDestino               :PChar;  CvesTransporte      :PChar;  UnidadPeso	   :PChar;  PesoBruto          :PChar;  PesoNeto      :PChar;  PesoTara   :PChar;   NumPiezas:PChar); cdecl;
  VirtualXML_CartaPorte10SetMercanciasAutotransporteFederalW: procedure ( p:LongInt; PermSCT:PChar; NumPermisoSCT:PChar; NombreAseg:PChar; NumPolizaSeguro:PChar; ConfigVehicular:PChar; PlacaVM:PChar;  AnioModeloVM:PChar;  SubTipoRem1:PChar; Placa1:PChar;  SubTipoRem2:PChar; Placa2:PChar ); cdecl;
  VirtualXML_CartaPorte10SetFiguraTransporteW               : procedure ( p:LongInt; CveTransporte:PChar ); cdecl;
  VirtualXML_CartaPorte10AddFiguraTransporteOperadoresW     : procedure ( p:LongInt; RFCOperador:PChar; NumLicencia:PChar; NombreOperador:PChar; NumRegIdTribOperador:PChar; ResidenciaFiscalOperador:PChar; Calle:PChar; NumeroExterior:PChar; NumeroInterior:PChar; Colonia:PChar; Localidad:PChar; Referencia:PChar; Municipio:PChar; Estado:PChar; Pais:PChar;  CodigoPostal:PChar ); cdecl;
  VirtualXML_GetValueW                                      : function  ( p:LongInt; value:LongInt ): PChar; cdecl;
  VirtualXML_ProcesaDocumentoW                              : function  ( p:LongInt; csd:PChar; key:PChar; keypwd:PChar; outfile:PChar ): LongInt; cdecl;
  VirtualXML_FreeW                                          : procedure ( p:LongInt ); cdecl;

begin

  hBar := LoadLibrary( 'VirtualXML.dll' );

  VirtualXML_NewW                                            := GetProcAddress ( Hbar, 'VirtualXML_NewW' );
  VirtualXML_SetVirtualPACInfoW                              := GetProcAddress ( Hbar, 'VirtualXML_SetVirtualPACInfoW' );
  VirtualXML_SetComprobanteInfo_cfdi33W                      := GetProcAddress ( Hbar, 'VirtualXML_SetComprobanteInfo_cfdi33W' );
  VirtualXML_SetEmisorInfo_cfdi33W                           := GetProcAddress ( Hbar, 'VirtualXML_SetEmisorInfo_cfdi33W' );
  VirtualXML_SetReceptorInfo_cfdi33W                         := GetProcAddress ( Hbar, 'VirtualXML_SetReceptorInfo_cfdi33W' );
  VirtualXML_AddConcepto_cfdi33W                             := GetProcAddress ( Hbar, 'VirtualXML_AddConcepto_cfdi33W' );
  VirtualXML_SetCartaPorte10W                                := GetProcAddress ( Hbar, 'VirtualXML_SetCartaPorte10W' );
  VirtualXML_CartaPorte10AddUbicacionW                       := GetProcAddress ( Hbar, 'VirtualXML_CartaPorte10AddUbicacionW' );
  VirtualXML_CartaPorte10SetMercanciasW                      := GetProcAddress ( Hbar, 'VirtualXML_CartaPorte10SetMercanciasW' );
  VirtualXML_CartaPorte10AddMercanciaW                       := GetProcAddress ( Hbar, 'VirtualXML_CartaPorte10AddMercanciaW' );
  VirtualXML_CartaPorte10SetMercanciasAutotransporteFederalW := GetProcAddress ( Hbar, 'VirtualXML_CartaPorte10SetMercanciasAutotransporteFederalW' );
  VirtualXML_CartaPorte10SetFiguraTransporteW                := GetProcAddress ( Hbar, 'VirtualXML_CartaPorte10SetFiguraTransporteW' );
  VirtualXML_CartaPorte10AddFiguraTransporteOperadoresW      := GetProcAddress ( Hbar, 'VirtualXML_CartaPorte10AddFiguraTransporteOperadoresW' );
  VirtualXML_ProcesaDocumentoW                               := GetProcAddress ( Hbar, 'VirtualXML_ProcesaDocumentoSSLW' );
  VirtualXML_GetValueW                                       := GetProcAddress ( Hbar, 'VirtualXML_GetValueW' );
  VirtualXML_FreeW                                           := GetProcAddress ( Hbar, 'VirtualXML_FreeW' );

  hXml := VirtualXML_NewW('3.3');

  VirtualXML_SetVirtualPacInfoW(hXml,'demo_cibertec','cibertec');

   // primero creamos un CFDI de Traslado o de Ingreso

   VirtualXML_SetComprobanteInfo_cfdi33W(hXml,'CP','001','%cb_date','','','0','0','XXX','','0','T','','02760','');
   VirtualXML_SetEmisorInfo_cfdi33W(hXml,'KIJ0906199R1', 'Empresa de Prueba, S.A. de C.V.','601');
   VirtualXML_SetReceptorInfo_cfdi33W(hXml, 'XAXX010101000', 'Mi sucursal en Monterrey, S.A. de C.V.', '', '', 'P01');
   VirtualXML_AddConcepto_cfdi33W(hXml, '12164502', '1158D10887', '1', 'H87', 'Pza', 'Articulo 1','0','0','');
   VirtualXML_AddConcepto_cfdi33W(hXml, '12164502', '1158D10887', '330', 'H87', 'Pza', 'Articulo 2','0','0','');

   // Complemento Carta Porte 1.0

   // No es importacion.
   VirtualXML_SetCartaPorte10W( hXml, 'No','','','900');

   // Agregamos 2 ubicaciones (o mas) en este ejemplo uno para el origen y otro para eldestino *
   VirtualXML_CartaPorte10AddUbicacionW(hXml,'','','','','','','','','','','2021-07-06T10:00:00','','','','','','','','','','Soledad','242','','0430','02','','002','DIF','MEX','02519');
   VirtualXML_CartaPorte10AddUbicacionW(hXml,'','900','','','','','','','','','','','','','','','','','','2021-07-06T14:00:00','AV. DE LAS INDUSTRIAS','518','','4331','03','','021','NLE','MEX','66062');


   // Mercancias
   VirtualXML_CartaPorte10SetMercanciasW(hXml,'','','','2','');

   // Repetimos los conceptos ahora con las claves necesarias de la carta porte
   VirtualXML_CartaPorte10AddMercanciaW(hXml,'12164502','','Articulo 1','1','H87','Pza','','','','','','20','','','','','','','','','','','','','');
   VirtualXML_CartaPorte10AddMercanciaW(hXml,'12164502','','Articulo 2','330','H87','Pza','','','','','','39.6','','','','','','','','','','','','','');

   // datos del autotransporte
  VirtualXML_CartaPorte10SetMercanciasAutotransporteFederalW(hXml,'TPAF01','0919dei0907201302100001002','Qualitas Seguros de Autos','7470035923','C3','204ES9','2014','','','','');

   // transporte propio
   VirtualXML_CartaPorte10SetFiguraTransporteW(hXml, '01');

   // datos del operador del transporte propio
   VirtualXML_CartaPorte10AddFiguraTransporteOperadoresW(hXml,'MUFC710807J75','DF0J233524','CARLOS MUNOZ FLORES','','','','','','','','','','','', '');

   i := VirtualXML_ProcesaDocumentoW(hXml,'CSD_KIJ0906199R1.cer','CSD_KIJ0906199R1.key','12345678a','CFDI33conCartaPorte.xml');
   if VirtualXML_GetValueW(hXml, 1) = 'VIRTUALXML_OK' then
    begin

      application.MessageBox(VirtualXML_GetValueW( hXML, 3),'No. de certificado del emisor' );
      application.MessageBox(VirtualXML_GetValueW( hXML, 4),'Sello digital del emisor');
      application.MessageBox(VirtualXML_GetValueW( hXML, 5),'Cadena original del documento');
      application.MessageBox(VirtualXML_GetValueW( hXML, 6),'No. de certificado del SAT');
      application.MessageBox(VirtualXML_GetValueW( hXML, 7),'Sello digital del timbre');
      application.MessageBox(VirtualXML_GetValueW( hXML, 8),'Cadena original del timbre');
      application.MessageBox(VirtualXML_GetValueW( hXML, 9),'UUID Folio fiscal');
      application.MessageBox(VirtualXML_GetValueW( hXML, 10),'Fecha de generacion del timbre');
      application.MessageBox(VirtualXML_GetValueW( hXML, 11),'Fecha de inicio de vigencia del certificado');
      application.MessageBox(VirtualXML_GetValueW( hXML, 12),'Fecha de terminacion de vigencia del certificado');
      application.MessageBox(VirtualXML_GetValueW( hXML, 13),'ID de operacion VirtualPAC');
      application.MessageBox(VirtualXML_GetValueW( hXML, 14),'Cantidad de timbres disponbiles');
      application.MessageBox(VirtualXML_GetValueW( hXML, 15),'Version de la libreria');
      application.MessageBox(VirtualXML_GetValueW( hXML, 16),'Fecha de emision del XML');
      application.MessageBox(VirtualXML_GetValueW( hXML, 17),'Mensaje del PAC');
      application.MessageBox(VirtualXML_GetValueW( hXML, 18),'PAC que certifico el documento');
      application.MessageBox(VirtualXML_GetValueW( hXML, 19),'No. de revision de la libreria');
      application.MessageBox(VirtualXML_GetValueW( hXML, 20),'RFC del proveedor de certificacion');
      application.MessageBox(VirtualXML_GetValueW( hXML, 21),'Leyenda del PAC');
    end
    else
      application.MessageBox(VirtualXML_GetValueW( hXML, 2),'Descripcion del error');

    VirtualXML_FreeW(hXML);

  FreeLibrary(Hbar);

  end;

{Complemento Carta Porte 2.0}
procedure TCFDI33.Button8Click(Sender: TObject);
var
  i: Integer;
  hBar: Thandle;

  VirtualXML_NewW                                                       : function  ( szVersion:PChar ): LongInt; cdecl;
  VirtualXML_SetVirtualPACInfoW                                         : procedure ( p:LongInt; szUser:PChar; servidor:PChar ); cdecl;
  VirtualXML_SetComprobanteInfo_cfdi33W                                 : procedure ( p:LongInt; Serie:PChar; Folio:PChar; Fecha:PChar; FormaPago:PChar; CondicionesDePago:PChar; SubTotal:PChar; Descuento:PChar; Moneda:PChar; TipoCambio:PChar; Total:PChar; TipoDeComprobante:PChar; MetodoPago:PChar; LugarExpedicion:PChar;  Confirmacion:PChar ); cdecl;
  VirtualXML_SetReceptorInfo_cfdi33W                                    : procedure ( p:LongInt; Rfc:PChar; Nombre:PChar; ResidenciaFiscal:PChar; NumRegIdTrib:PChar; UsoCFDI:PChar ); cdecl;
  VirtualXML_SetEmisorInfo_cfdi33W                                      : procedure ( p:LongInt; Rfc:PChar; Nombre:PChar; RegimenFiscal:PChar ); cdecl;
  VirtualXML_AddConcepto_cfdi33W                                        : procedure ( p:LongInt; ClaveProdServ:PChar; NoIdentificacion:PChar; Cantidad:PChar; ClaveUnidad:PChar; Unidad:PChar; Descripcion:PChar; ValorUnitario:PChar; Importe:PChar; Descuento:PChar ); cdecl;
  VirtualXML_AddConceptoTraslado_cfdi33W                                : procedure ( p:LongInt; Base:PChar; Impuesto:PChar; TipoFactor:PChar; TasaOCuota:PChar; Importe:PChar ); cdecl;
  VirtualXML_AddConceptoRetencion_cfdi33W                               : procedure ( p:LongInt; Base:PChar; Impuesto:PChar; TipoFactor:PChar; TasaOCuota:PChar; Importe:PChar ); cdecl;
  VirtualXML_SetImpuestosInfo_cfdi33W                                   : procedure ( p:LongInt; TotalImpuestosTrasladados:PChar; TotalImpuestosRetenidos:PChar ); cdecl;
  VirtualXML_AddRetencion_cfdi33W                                       : procedure ( p:LongInt; Impuesto:PChar; Importe:PChar ); cdecl;
  VirtualXML_AddTraslado_cfdi33W                                        : procedure ( p:LongInt; Impuesto:PChar; TipoFactor:PChar; TasaOCuota:PChar; Importe:PChar ); cdecl;
  VirtualXML_SetCartaPorte20W                                           : procedure ( p:LongInt; TranspInternac:PChar; EntradaSalidaMerc:PChar; PaisOrigenDestino:PChar;  ViaEntradaSalida:PChar; TotalDistRec:PChar);cdecl;
  VirtualXML_CartaPorte20AddUbicacionW                                  : procedure ( p:LongInt; TipoUbicacion:PChar; IDUbicacion:PChar; RFCRemitenteDestinatario:PChar; NombreRemitenteDestinatario:PChar; NumRegIdTrib:PChar; ResidenciaFiscal:PChar; NumEstacion:PChar; NombreEstacion:PChar; NavegacionTrafico:PChar; FechaHoraSalidaLlegada:PChar; TipoEstacion:PChar; DistanciaRecorrida:PChar; Calle:PChar; NumeroExterior:PChar; NumeroInterior:PChar; Colonia:PChar; Localidad:PChar; Referencia:PChar; Municipio:PChar; Estado:PChar; Pais:PChar; CodigoPostal:PChar);cdecl;
  VirtualXML_CartaPorte20SetMercanciasW                                 : procedure ( p:LongInt; PesoBrutoTotal:PChar; UnidadPeso:PChar; PesoNetoTotal:PChar; NumTotalMercancias:PChar; CargoPorTasacion:PChar);cdecl;
  VirtualXML_CartaPorte20AddMercanciaW                                  : procedure ( p:LongInt; BienesTransp:PChar; ClaveSTCC:PChar; Descripcion:PChar; Cantidad:PChar; ClaveUnidad:PChar; Unidad:PChar; Dimensiones:PChar; MaterialPeligroso:PChar; CveMaterialPeligroso:PChar; Embalaje:PChar; DescripEmbalaje:PChar; PesoEnKg:PChar; ValorMercancia:PChar; Moneda:PChar; FraccionArancelaria:PChar; UUIDComercioExt:PChar; UnidadPesoMerc:PChar; PesoBruto:PChar; PesoNeto:PChar; PesoTara:PChar; NumPiezas:PChar);cdecl;
  VirtualXML_CartaPorte20AddMercanciaCantidadTransportaW                : procedure ( p:LongInt; Cantidad:PChar; IDOrigen:PChar; IDDestino:PChar; CvesTransporte:PChar);cdecl;
  VirtualXML_CartaPorte20SetMercanciasAutotransporteW                   : procedure ( p:LongInt; PermSCT:PChar; NumPermisoSCT:PChar; ConfigVehicular:PChar; PlacaVM:PChar; AnioModeloVM:PChar; AseguraRespCivil:PChar; PolizaRespCivil:PChar; AseguraMedAmbiente:PChar; PolizaMedAmbiente:PChar; AseguraCarga:PChar; PolizaCarga:PChar; PrimaSeguro:PChar; SubTipoRem1:PChar; Placa1:PChar; SubTipoRem2:PChar; Placa2:PChar); cdecl;
  VirtualXML_CartaPorte20AddFiguraTransporteTiposFiguraW                : procedure ( p:LongInt; TipoFigura:PChar; RFCFigura:PChar; NumLicencia:PChar; NombreFigura:PChar; NumRegIdTribFigura:PChar; ResidenciaFiscalFigura:PChar; ParteTransporte:PChar; Calle:PChar; NumeroExterior:PChar; NumeroInterior:PChar; Colonia:PChar; Localidad:PChar; Referencia:PChar; Municipio:PChar; Estado:PChar; Pais:PChar; CodigoPostal:PChar);cdecl;
  VirtualXML_CartaPorte20AddFiguraTransporteTiposFiguraPartesTransporteW: procedure ( p:LongInt; ParteTransporte:PChar); cdecl;
  VirtualXML_GetValueW                                                  : function  ( p:LongInt; value:LongInt ): PChar; cdecl;
  VirtualXML_ProcesaDocumentoW                                          : function  ( p:LongInt; csd:PChar; key:PChar; keypwd:PChar; outfile:PChar ): LongInt; cdecl;
  VirtualXML_FreeW                                                      : procedure ( p:LongInt ); cdecl;

begin

    Hbar := LoadLibrary( 'VirtualXML.dll' );

    VirtualXML_NewW                                                        := GetProcAddress ( Hbar, 'VirtualXML_NewW' );
    VirtualXML_SetVirtualPACInfoW                                          := GetProcAddress ( Hbar, 'VirtualXML_SetVirtualPACInfoW' );
    VirtualXML_SetComprobanteInfo_cfdi33W                                  := GetProcAddress ( Hbar, 'VirtualXML_SetComprobanteInfo_cfdi33W' );
    VirtualXML_SetEmisorInfo_cfdi33W                                       := GetProcAddress ( Hbar, 'VirtualXML_SetEmisorInfo_cfdi33W' );
    VirtualXML_SetReceptorInfo_cfdi33W                                     := GetProcAddress ( Hbar, 'VirtualXML_SetReceptorInfo_cfdi33W' );
    VirtualXML_AddConcepto_cfdi33W                                         := GetProcAddress ( Hbar, 'VirtualXML_AddConcepto_cfdi33W' );
    VirtualXML_AddConceptoRetencion_cfdi33W                                := GetProcAddress ( Hbar, 'VirtualXML_AddConceptoRetencion_cfdi33W' );
    VirtualXML_AddConceptoTraslado_cfdi33W                                 := GetProcAddress ( Hbar, 'VirtualXML_AddConceptoTraslado_cfdi33W' );
    VirtualXML_SetImpuestosInfo_cfdi33W                                    := GetProcAddress ( Hbar, 'VirtualXML_SetImpuestosInfo_cfdi33W' );
    VirtualXML_AddRetencion_cfdi33W                                        := GetProcAddress ( Hbar, 'VirtualXML_AddRetencion_cfdi33W');
    VirtualXML_AddTraslado_cfdi33W                                         := GetProcAddress ( Hbar, 'VirtualXML_AddTraslado_cfdi33W' );
    VirtualXML_SetCartaPorte20W                                            := GetProcAddress ( Hbar, 'VirtualXML_SetCartaPorte20W');
    VirtualXML_CartaPorte20AddUbicacionW                                   := GetProcAddress ( Hbar, 'VirtualXML_CartaPorte20AddUbicacionW');
    VirtualXML_CartaPorte20SetMercanciasW                                  := GetProcAddress ( Hbar, 'VirtualXML_CartaPorte20SetMercanciasW');
    VirtualXML_CartaPorte20AddMercanciaW                                   := GetProcAddress ( Hbar, 'VirtualXML_CartaPorte20AddMercanciaW');
    VirtualXML_CartaPorte20AddMercanciaCantidadTransportaW                 := GetProcAddress ( Hbar, 'VirtualXML_CartaPorte20AddMercanciaCantidadTransportaW');
    VirtualXML_CartaPorte20SetMercanciasAutotransporteW                    := GetProcAddress ( Hbar, 'VirtualXML_CartaPorte20SetMercanciasAutotransporteW');
    VirtualXML_CartaPorte20AddFiguraTransporteTiposFiguraW                 := GetProcAddress ( Hbar, 'VirtualXML_CartaPorte20AddFiguraTransporteTiposFiguraW');
    VirtualXML_CartaPorte20AddFiguraTransporteTiposFiguraPartesTransporteW := GetProcAddress ( Hbar, 'VirtualXML_CartaPorte20AddFiguraTransporteTiposFiguraPartesTransporteW');
    VirtualXML_ProcesaDocumentoW                                           := GetProcAddress ( Hbar, 'VirtualXML_ProcesaDocumentoSSLW' );
    VirtualXML_GetValueW                                                   := GetProcAddress ( Hbar, 'VirtualXML_GetValueW' );
    VirtualXML_FreeW                                                       := GetProcAddress ( Hbar, 'VirtualXML_FreeW' );


    hXml := VirtualXML_NewW('3.3');


    VirtualXML_SetVirtualPACInfoW(hXml, 'demo_cibertec', 'cibertec');

   { Creamos un CFDI de ingreso o traslado }
   VirtualXML_SetComprobanteInfo_cfdi33W(hXml, 'CP2','001', '%cb_date', '01', '', '25000.00', '', 'MXN', '1', '28000.00', 'I', 'PUE', '06300', '');
   VirtualXML_SetEmisorInfo_cfdi33W(hXml, 'KIJ0906199R1', 'Emisor de Pruebas, S.A. de C.V', '601');
   VirtualXML_SetReceptorInfo_cfdi33W(hXml,'XAXX010101000','Receptor de Prueba','','','G03');
   VirtualXML_AddConcepto_cfdi33W(hXml,'78101500','01','1','E48','SERVICIO','Flete de mercancias','25000.00','25000.00','');
   VirtualXML_AddConceptoRetencion_cfdi33W(hXml,'25000.00','002','Tasa','0.040000','1000.00');
   VirtualXML_AddConceptoTraslado_cfdi33W(hXml,'25000.00','002','Tasa','0.160000','4000.00');
   VirtualXML_SetImpuestosInfo_cfdi33W(hXml,'4000.00','1000.00');
   VirtualXML_AddRetencion_cfdi33W(hXml,'002','1000.00');
   VirtualXML_AddTraslado_cfdi33W(hXml,'002','Tasa','0.160000','4000.00');

   { inicia Carta Porte 2.0 }
   VirtualXML_SetCartaPorte20W(hXml,'No','','','','2');

   { Agregamos ubicaciones de origen y destino }
   VirtualXML_CartaPorte20AddUbicacionW(hXml,'Origen','OR101010','EKU9003173C9','','','','','','','2021-11-01T00:00:00','','','calle origen 1','211','','0347','23','','004','COA','MEX','25350');
   VirtualXML_CartaPorte20AddUbicacionW(hXml,'Destino','DE202020','AAA010101AAA','','','','','','','2021-11-01T01:00:00','','1','calle destino 1','214','','0347','23','entre av. lazaro cardenas y calle 32','004','COA','MEX','25350');
   VirtualXML_CartaPorte20AddUbicacionW(hXml,'Destino','DE202021','AAA010101AAA','','','','','','','2021-11-01T02:00:00','','1','calle destino 2','125','','0347','23','Zorro Abarrotero','004','COA','MEX','25350');

   { Agregamos informacion de Mercancias }
   VirtualXML_CartaPorte20SetMercanciasW(hXml,'2.0','XBX','','2','');
   VirtualXML_CartaPorte20AddMercanciaW(hXml,'11121900','','Mercancia 1','1.0','XBX','','','S','1266','4H2','','1.0','','','','','','','','','');
   VirtualXML_CartaPorte20AddMercanciaCantidadTransportaW(hXml,'1','OR101010','DE202020','');
   VirtualXML_CartaPorte20AddMercanciaW(hXml,'11121900','','Mercancia 2','1.0','XBX','','','S','1266','4H2','','1.0','','','','','','','','','');
   VirtualXML_CartaPorte20AddMercanciaCantidadTransportaW(hXml,'1','OR101010','DE202021','');

   { informacion del vehiculo que transporta las mercancias }
   VirtualXML_CartaPorte20SetMercanciasAutotransporteW(hXml,'TPAF01','NumPermisoSCT','VL','PLAC892','2009','Seguros Atlas','123456789','GNP Seguros','123456789','ABA Seguros','','','CTR003','PAX1234','','');

   { finalmente agregamos las figuras de transporte }
   VirtualXML_CartaPorte20AddFiguraTransporteTiposFiguraW(hXml,'01','PEMJ420113SG1','a234567890','Vazquez Armenta Macario','','','','Brisa','423','','0347','23','Atras del estadio','004','COA','MEX','25350');
   VirtualXML_CartaPorte20AddFiguraTransporteTiposFiguraW(hXml,'02','PEMJ420113SG1','','Fonseca Larrea Raul','','','PT01','Padre Lerchundi','523','','0347','23','','004','COA','MEX','25350');
   VirtualXML_CartaPorte20AddFiguraTransporteTiposFiguraPartesTransporteW(hXml,'PT02');
   VirtualXML_CartaPorte20AddFiguraTransporteTiposFiguraW(hXml,'04','PEMJ420113SG1','','','','','','Otra calle de prueba','45','','0347','23','','004','COA','MEX','25350');

   { procesamos el docuemento }
   i := VirtualXML_ProcesaDocumentoW(hXml,'CSD_KIJ0906199R1.cer','CSD_KIJ0906199R1.key','12345678a','CFDI33CartaPorte20.xml');
   if VirtualXML_GetValueW(hXml, 1) = 'VIRTUALXML_OK' then
    begin

      application.MessageBox(VirtualXML_GetValueW( hXML, 3),'No. de certificado del emisor' );
      application.MessageBox(VirtualXML_GetValueW( hXML, 4),'Sello digital del emisor');
      application.MessageBox(VirtualXML_GetValueW( hXML, 5),'Cadena original del documento');
      application.MessageBox(VirtualXML_GetValueW( hXML, 6),'No. de certificado del SAT');
      application.MessageBox(VirtualXML_GetValueW( hXML, 7),'Sello digital del timbre');
      application.MessageBox(VirtualXML_GetValueW( hXML, 8),'Cadena original del timbre');
      application.MessageBox(VirtualXML_GetValueW( hXML, 9),'UUID Folio fiscal');
      application.MessageBox(VirtualXML_GetValueW( hXML, 10),'Fecha de generacion del timbre');
      application.MessageBox(VirtualXML_GetValueW( hXML, 11),'Fecha de inicio de vigencia del certificado');
      application.MessageBox(VirtualXML_GetValueW( hXML, 12),'Fecha de terminacion de vigencia del certificado');
      application.MessageBox(VirtualXML_GetValueW( hXML, 13),'ID de operacion VirtualPAC');
      application.MessageBox(VirtualXML_GetValueW( hXML, 14),'Cantidad de timbres disponbiles');
      application.MessageBox(VirtualXML_GetValueW( hXML, 15),'Version de la libreria');
      application.MessageBox(VirtualXML_GetValueW( hXML, 16),'Fecha de emision del XML');
      application.MessageBox(VirtualXML_GetValueW( hXML, 17),'Mensaje del PAC');
      application.MessageBox(VirtualXML_GetValueW( hXML, 18),'PAC que certifico el documento');
      application.MessageBox(VirtualXML_GetValueW( hXML, 19),'No. de revision de la libreria');
      application.MessageBox(VirtualXML_GetValueW( hXML, 20),'RFC del proveedor de certificacion');
      application.MessageBox(VirtualXML_GetValueW( hXML, 21),'Leyenda del PAC');
    end
    else
      application.MessageBox(VirtualXML_GetValueW( hXML, 2),'Descripcion del error');

    VirtualXML_FreeW(hXML);

  FreeLibrary(Hbar);


end;

end.

{
VirtualXML_NewW                                                           : function  ( szVersion:PChar ): LongInt; cdecl;
VirtualXML_ProcesaDocumentoW                                              : function  ( p:LongInt; csd:PChar; key:PChar; keypwd:PChar; outfile:PChar ): LongInt; cdecl;
VirtualXML_ProcesaDocumentoSSLW                                           : function  ( p:LongInt; csd:PChar; key:PChar; keypwd:PChar; outfile:PChar ): LongInt; cdecl;
VirtualXML_GetValueW                                                      : function  ( p:LongInt; value:LongInt ): PChar; cdecl;
VirtualXML_GetTimeWithDelayW                                              : function  ( p:LongInt; nSegs:LongInt ): PChar; cdecl;
VirtualXML_CancelaUUIDW                                                   : function  ( szUser:PChar; szEmisor:PChar; szCert:PChar; szKey:PChar; szPwd:PChar; szUuid:PChar; szOut:PChar ): LongInt; cdecl;
VirtualXML_CancelaCFDIW                                                   : function  ( szUser:PChar; szEmisor:PChar; szReceptor:PChar; szTotal:PChar; szUuid:PChar; szCert:PChar; szKey:PChar; szPwd:PChar; szResult:PChar; szLog:PChar ): LongInt; cdecl;
VirtualXML_GetStatusCFDIW                                                 : function  ( szUser:PChar; szEmisor:PChar; szReceptor:PChar; szTotal:PChar; szUuid:PChar; szResult:PChar; szLog:PChar ): LongInt; cdecl;
VirtualXML_RecuperaAcuseCancelacionW                                      : function  ( sZUser:PChar; sZemisor:PChar; SzUuid:PChar; sZResult:PChar; szXMLAcuse:PChar; szLog:PChar; sZreserved:PChar ): LongInt; cdecl;
VirtualXML_CerKeyMatchW                                                   : function  ( p:LongInt; szEmisor:PChar; szCSD:PChar; szKey:PChar; szKeyPwd:PChar ): LongInt; cdecl;
VirtualXML_CheckLicenceW                                                  : function  ( user:PChar; llave:PChar; emisor:PChar ): LongInt; cdecl;
VirtualXML_CheckFileW                                                     : function  ( szFile:PChar ): LongInt; cdecl;
VirtualXML_LoadW                                                          : function  ( Archivo:PChar ): LongInt; cdecl;
VirtualXML_CerTo64W                                                       : function  ( ArchivoCer:PChar ): PChar; cdecl;
VirtualXML_FileTo64W                                                      : function  ( Archivo:PChar ): PChar; cdecl;
VirtualXML_ConsultaSaldosW                                                : function  ( usuario:PChar; rfcEmisor:PChar; DatoSolicitado:LongInt; ArchivoLog:PChar ): LongInt; cdecl;
VirtualXML_FirmaSellaDoctoW                                               : function  ( p:LongInt; csd:PChar; key:PChar; keypwd:PChar; outfile:PChar ): LongInt; cdecl;
VirtualXML_ConsultaEstadoCFDIW                                            : function  ( rfcEmisor :PChar; rfcReceptor:PChar; Total:PChar; UUID:PChar; OutLog:PChar ): LongInt; cdecl;
VirtualXML_GeneraCBBW                                                     : function  ( Datos:PChar; Archivo:PChar; Dependencias:LongInt; RutaLog:PChar; AddLog:LongInt; Escala:LongInt; Margen:LongInt ): LongInt ; cdecl;
VirtualXML_MasivaDescargaW                                                : function  ( Usuario:PChar; ArchivoCerFiel:PChar; ArchivoKeyFiel:PChar; PwdKey:PChar; IdPaquete:PChar; ArchivoDescargado:PChar; ArchLog:PChar; Reservado:PChar ): LongInt; cdecl;
VirtualXML_MasivaSolicitaEmitidoXMLW                                      : function  ( Usuario:PChar; ArchivoCerFiel:PChar; ArchivoKeyFiel:PChar; PwdKey:PChar; RfcReceptor:PChar; FechaDesde:PChar; FechaHasta:PChar; ArchResultado:PChar; ArchLog:PChar; Reservado:PChar ): LongInt; cdecl;
VirtualXML_MasivaSolicitaEmitidoMetadataW                                 : function  ( Usuario:PChar; ArchivoCerFiel:PChar; ArchivoKeyFiel:PChar; PwdKey:PChar; RfcReceptor:PChar; FechaDesde:PChar; FechaHasta:PChar; ArchResultado:PChar; ArchLog:PChar; Reservado:PChar ): LongInt; cdecl;
VirtualXML_MasivaSolicitaRecibidoXMLW                                     : function  ( Usuario:PChar; ArchivoCerFiel:PChar; ArchivoKeyFiel:PChar; PwdKey:PChar; RfcEmisor:PChar; FechaDesde:PChar; FechaHasta:PChar; ArchResultado:PChar; ArchLog:PChar; Reservado:PChar ): LongInt; cdecl;
VirtualXML_MasivaSolicitaRecibidoMetadataW                                : function  ( Usuario:PChar; ArchivoCerFiel:PChar; ArchivoKeyFiel:PChar; PwdKey:PChar; RfcEmisor:PChar; FechaDesde:PChar; FechaHasta:PChar; ArchResultado:PChar; ArchLog:PChar; Reservado:PChar ): LongInt; cdecl;
VirtualXML_MasivaVerificaW                                                : function  ( Usuario:PChar; ArchivoCerFiel:PChar; ArchivoKeyFiel:PChar; PwdKey:PChar; IdSolicitud:PChar; ArchResultado:PChar; ArchLog:PChar; Reservado:PChar ): LongInt; cdecl;
VirtualXML_FreeW                                                          : procedure ( p:LongInt ); cdecl;
VirtualXML_SetVirtualPACInfoW                                             : procedure ( p:LongInt; szUser:PChar; servidor:PChar ); cdecl;
VirtualXML_SetCiberSATInfoW                                               : procedure ( p:LongInt; userCiberPAC:PChar; llaveCiberPAC:PChar ); cdecl;
VirtualXML_SetComprobanteInfoW                                            : procedure ( p:LongInt; serie:PChar; folio:PChar; fecha:PChar; tipoDeComprobante:PChar; formaDePago:PChar; subtotal:PChar; descuento:PChar; total:PChar; moneda:PChar; tipoCambio:PChar; condicionesDePago:PChar; metodoDePago:PChar; motivoDescuento:PChar ); cdecl;
VirtualXML_SetImpuestosLocalesInfoW                                       : procedure ( p:LongInt; TotaldeTraslados:PChar; TotaldeRetenciones:PChar ); cdecl;
VirtualXML_AddImpuestoLocalRetenidoW                                      : procedure ( p:LongInt; ImpLocRetenido:PChar; TasadeRetencion:PChar; Importe:PChar ); cdecl;
VirtualXML_AddImpuestoLocalTrasladadoW                                    : procedure ( p:LongInt; ImpLocTrasladado:PChar; TasadeTraslado:PChar; Importe:PChar ); cdecl;
VirtualXML_AddDonatarias11W                                               : procedure ( p:LongInt; noAutorizacion:PChar; fechaAutorizacion:PChar; leyenda:PChar ); cdecl;
VirtualXML_SetDllPathW                                                    : procedure ( p:LongInt; DllPath:PChar ); cdecl;
VirtualXML_GetValueInFileW                                                : procedure ( p:LongInt; value:LongInt; archivo:PChar ); cdecl;
VirtualXML_ProcessFileW                                                   : procedure ( szFile:PChar ); cdecl;
VirtualXML_SetLogFileW                                                    : procedure ( p:LongInt; archivo:PChar ); cdecl;
VirtualXML_ShowValueW                                                     : procedure ( p:LongInt; lValue:LongInt; title:PChar ); cdecl;
VirtualXML_SaveW                                                          : procedure ( p:LongInt; archivo:PChar ); cdecl;
VirtualXML_GetValuesW                                                     : procedure ( p:LongInt; archivo:PChar; lFormat:LongInt ); cdecl;
VirtualXML_SetNomina12W                                                   : procedure ( p:LongInt; TipoNomina:PChar; FechaPago:PChar; FechaInicialPago:PChar; FechaFinalPago:PChar; NumDiasPagados:PChar; TotalPercepciones:PChar; TotalDeducciones:PChar; TotalOtrosPagos:PChar ); cdecl;
VirtualXML_Nomina12SetEmisorW                                             : procedure ( p:LongInt; Curp:PChar; RegistroPatronal:PChar; RfcPatronOrigen:PChar; OrigenRecurso:PChar; MontoRecursoPropio :PChar ); cdecl;
VirtualXML_Nomina12SetReceptorW                                           : procedure ( p:LongInt; Curp:PChar; NumSeguridadSocial:PChar; FechaInicioRelLaboral:PChar; Antiguedad:PChar; TipoContrato:PChar; Sindicalizado:PChar; TipoJornada:PChar; TipoRegimen:PChar; NumEmpleado:PChar; Departamento:PChar; Puesto:PChar; RiesgoPuesto:PChar; PeriodicidadPago:PChar; Banco:PChar; CuentaBancaria:PChar; SalarioBaseCotApor:PChar;  SalarioDiarioIntegrado:PChar;  ClaveEntFed:PChar ); cdecl;
VirtualXML_Nomina12AddSubContratacionW                                    : procedure ( p:LongInt; RfcLabora:PChar; PorcentajeTiempo:PChar ); cdecl;
VirtualXML_Nomina12SetPercepcionesW                                       : procedure ( p:LongInt; TotalSueldos:PChar; TotalSeparacionIndemnizacion:PChar; TotalJubilacionPensionRetiro:PChar; TotalGravado:PChar; TotalExento:PChar ); cdecl;
VirtualXML_Nomina12AddPercepcionW                                         : procedure ( p:LongInt; TipoPercepcion:PChar; Clave:PChar; Concepto:PChar; ImporteGravado:PChar; ImporteExento:PChar; Dias:PChar; TipoHoras:PChar; HorasExtra:PChar; ImportePagado:PChar; ValorMercado:PChar; PrecioAlOtorgarse:PChar ); cdecl;
VirtualXML_Nomina12SetJubilacionPensionRetiroW                            : procedure ( p:LongInt; TotalUnaExhibicion:PChar; TotalParcialidad:PChar; MontoDiario:PChar; IngresoAcumulable:PChar; IngresoNoAcumulable:PChar ); cdecl;
VirtualXML_Nomina12SetSeparacionIndemnizacionW                            : procedure ( p:LongInt; TotalPagado:PChar; NumAniosServicio:PChar; UltimoSueldoMensOrd:PChar; IngresoAcumulable:PChar; IngresoNoAcumulable:PChar ); cdecl;
VirtualXML_Nomina12SetDeduccionesW                                        : procedure ( p:LongInt; TotalOtrasDeducciones:PChar; TotalImpuestosRetenidos:PChar ); cdecl;
VirtualXML_Nomina12AddDeduccionW                                          : procedure ( p:LongInt; TipoDeduccion:PChar; Clave:PChar; Concepto:PChar; Importe:PChar ); cdecl;
VirtualXML_Nomina12AddOtroPagoW                                           : procedure ( p:LongInt; TipoOtroPago:PChar; Clave:PChar; Concepto:PChar; Importe:PChar; SaldoAFavor:PChar; Anio:PChar; RemanenteSalFav:PChar; SubsidioCausado:PChar ); cdecl;
VirtualXML_Nomina12AddIncapacidadW                                        : procedure ( p:LongInt; DiasIncapacidad:PChar; TipoIncapacidad:PChar; ImporteMonetario:PChar ); cdecl;
VirtualXML_SetCompleteXML_cfdi33W                                         : procedure ( p:LongInt; XMLCompleto:PChar ); cdecl;
VirtualXML_SetCfdiRelacionados_cfdi33W                                    : procedure ( p:LongInt; TipoRelacion:PChar ); cdecl;
VirtualXML_SetPagos10W                                                    : procedure ( p:LongInt ); cdecl ;
VirtualXML_AddConceptoCuentaPredial_cfdi33W                               : procedure ( p:LongInt; Numero:PChar ); cdecl ;
VirtualXML_AddConceptoInformacionAduanera_cfdi33W                         : procedure ( p:LongInt; NumeroPedimento:PChar ); cdecl;
VirtualXML_SetAddendaText_cfdi33W                                         : procedure ( p:LongInt; text:PChar ); cdecl;
VirtualXML_AddComplemento_cfdi33W                                         : procedure ( p:LongInt; complementoXml:PChar ); cdecl;
VirtualXML_SetAddenda_cfdi33W                                             : procedure ( p:LongInt; text:PChar ); cdecl;
VirtualXML_AddEntidadContabilidadW                                        : procedure ( p:LongInt; IdContabilidad:PChar ); cdecl;
VirtualXML_AddCfdiRelacionado_cfdi33W                                     : procedure ( p:LongInt; UUID:PChar ); cdecl;
VirtualXML_CartaPorte10SetFiguraTransporteW                               : procedure ( p:LongInt; CveTransporte:PChar ); cdecl;
VirtualXML_SetImpuestosInfo_cfdi33W                                       : procedure ( p:LongInt; TotalImpuestosTrasladados:PChar; TotalImpuestosRetenidos:PChar ); cdecl;
VirtualXML_AddRetencion_cfdi33W                                           : procedure ( p:LongInt; Impuesto:PChar; Importe:PChar ); cdecl;
VirtualXML_CCE11AddPropietarioW                                           : procedure ( p:LongInt; NumRegIdTrib:PChar; ResidenciaFiscal:PChar ); cdecl;
VirtualXML_CartaPorte10AddMercanciasTransporteFerroviarioDerechosDePasoW  : procedure ( p:LongInt; TipoDerechoDePaso:PChar; KilometrajePagado:PChar ); cdecl;
VirtualXML_CCE11AddMercanciaDescripcionesEspecificasW                     : procedure ( p:LongInt; Marca:PChar; Modelo:PChar; SubModelo:PChar; NumeroSerie:PChar ); cdecl;
VirtualXML_SetEmisorInfo_cfdi33W                                          : procedure ( p:LongInt; Rfc:PChar; Nombre:PChar; RegimenFiscal:PChar ); cdecl;
VirtualXML_AddEntidadW                                                    : procedure ( p:LongInt; ClaveEntidad:PChar; Ambito:PChar; IdContabilidad:PChar ); cdecl;
VirtualXML_SetLeyendasFiscales10W                                         : procedure ( p:LongInt; Disposicion:PChar; Norma:PChar; TextoLeyenda:PChar ); cdecl;
VirtualXML_CartaPorte10AddMercanciasTransporteMaritimoContenedorW         : procedure ( p:LongInt; MatriculaContenedor:PChar; TipoContenedor:PChar; NumPrecinto:PChar ); cdecl;
VirtualXML_CartaPorte10AddMercanciasTransporteFerroviarioCarroContenedorW : procedure ( p:LongInt; TipoContenedor:PChar; PesoContenedorVacio:PChar; PesoNetoMercancia:PChar ); cdecl;
VirtualXML_AddTraslado_cfdi33W                                            : procedure ( p:LongInt; Impuesto:PChar; TipoFactor:PChar; TasaOCuota:PChar; Importe:PChar ); cdecl;
VirtualXML_SetCartaPorte10W                                               : procedure ( p:LongInt; TranspInternac:PChar; EntradaSalidaMerc:PChar; ViaEntradaSalida:PChar; TotalDistRec:PChar ); cdecl;
VirtualXML_CartaPorte10AddMercanciaCantidadTransportaW                    : procedure ( p:LongInt; Cantidad:PChar; IDOrigen:PChar; IDDestino:PChar; CvesTransporte:PChar ); cdecl;
VirtualXML_SetReceptorInfo_cfdi33W                                        : procedure ( p:LongInt; Rfc:PChar; Nombre:PChar; ResidenciaFiscal:PChar; NumRegIdTrib:PChar; UsoCFDI:PChar ); cdecl;
VirtualXML_AddConceptoTraslado_cfdi33W                                    : procedure ( p:LongInt; Base:PChar; Impuesto:PChar; TipoFactor:PChar; TasaOCuota:PChar; Importe:PChar ); cdecl;
VirtualXML_AddConceptoRetencion_cfdi33W                                   : procedure ( p:LongInt; Base:PChar; Impuesto:PChar; TipoFactor:PChar; TasaOCuota:PChar; Importe:PChar ); cdecl;
VirtualXML_AddConceptoComplementoIedu_cfdi33W                             : procedure ( p:LongInt; nombreAlumno:PChar; CURP:PChar; nivelEducativo:PChar; autRVOE:PChar; rfcPago:PChar ); cdecl;
VirtualXML_CartaPorte10SetMercanciasW                                     : procedure ( p:LongInt; PesoBrutoTotal:PChar; UnidadPeso:PChar; PesoNetoTotal:PChar; NumTotalMercancias:PChar; CargoPorTasacion:PChar ); cdecl;
VirtualXML_SetINE11W                                                      : procedure ( p:LongInt; TipoProceso:PChar; TipoComite:PChar; IdContabilidad:PChar; ClaveEntidad:PChar; Ambito:PChar; EntidadContabilidadIdContabilidad:PChar ); cdecl;
VirtualXML_CartaPorte10AddMercanciasTransporteFerroviarioCarroW           : procedure ( p:LongInt; TipoCarro:PChar; MatriculaCarro:PChar; GuiaCarro:PChar; ToneladasNetasCarro:PChar; TipoContenedor:PChar; PesoContenedorVacio:PChar; PesoNetoMercancia:PChar ); cdecl;
VirtualXML_AddConceptoParte_cfdi33W                                       : procedure ( p:LongInt; ClaveProdServ:PChar; NoIdentificacion:PChar; Cantidad:PChar; Unidad:PChar; Descripcion:PChar; ValorUnitario:PChar; Importe:PChar; NumeroPedimento:PChar ); cdecl;
VirtualXML_AddConcepto_cfdi33W                                            : procedure ( p:LongInt; ClaveProdServ:PChar; NoIdentificacion:PChar; Cantidad:PChar; ClaveUnidad:PChar; Unidad:PChar; Descripcion:PChar; ValorUnitario:PChar; Importe:PChar; Descuento:PChar ); cdecl;
VirtualXML_SetServicioParcial10W                                          : procedure ( p:LongInt; NumPerLicoAut:PChar; Calle:PChar; NoExterior:PChar; NoInterior:PChar; Colonia:PChar; Localidad:PChar; Referencia:PChar; Municipio:PChar; Estado:PChar; CodigoPostal:PChar ); cdecl;
VirtualXML_Pagos10AddPagoDoctoRelacionadoW                                : procedure ( p:LongInt; IdDocumento:PChar; Serie:PChar; Folio:PChar; MonedaDR:PChar; TipoCambioDR:PChar; MetodoDePagoDR:PChar; NumParcialidad:PChar; ImpSaldoAnt:PChar; ImpPagado:PChar; ImpSaldoInsoluto:PChar ); cdecl;
VirtualXML_CCE11AddMercanciaW                                             : procedure ( p:LongInt; NoIdentificacion:PChar; FraccionArancelaria:PChar; CantidadAduana:PChar; UnidadAduana:PChar; ValorUnitarioAduana:PChar; ValorDolares:PChar;  Marca:PChar; Modelo:PChar; SubModelo:PChar; NumeroSerie:PChar ); cdecl;
VirtualXML_SetComercioExterior11W                                         : procedure ( p:LongInt; MotivoTraslado:PChar; TipoOperacion:PChar; ClaveDePedimento:PChar; CertificadoOrigen:PChar; NumCertificadoOrigen:PChar; NumeroExportadorConfiable:PChar;  Incoterm:PChar;  Subdivision:PChar; Observaciones:PChar;  TipoCambioUSD:PChar; TotalUSD:PChar ); cdecl;
VirtualXML_CCE11SetEmisorW                                                : procedure ( p:LongInt; Curp:PChar; Calle:PChar; NumeroExterior:PChar; NumeroInterior:PChar; Colonia:PChar; Localidad:PChar;  Referencia:PChar;  Municipio:PChar; Estado:PChar;  Pais:PChar; CodigoPostal:PChar ); cdecl;
VirtualXML_CCE11SetReceptorW                                              : procedure ( p:LongInt; NumRegIdTrib:PChar; Calle:PChar; NumeroExterior:PChar; NumeroInterior:PChar; Colonia:PChar; Localidad:PChar;  Referencia:PChar;  Municipio:PChar; Estado:PChar;  Pais:PChar; CodigoPostal:PChar ); cdecl;
VirtualXML_CartaPorte10SetMercanciasAutotransporteFederalW                : procedure ( p:LongInt; PermSCT:PChar; NumPermisoSCT:PChar; NombreAseg:PChar; NumPolizaSeguro:PChar; ConfigVehicular:PChar; PlacaVM:PChar;  AnioModeloVM:PChar;  SubTipoRem1:PChar; Placa1:PChar;  SubTipoRem2:PChar; Placa2:PChar ); cdecl;
VirtualXML_CCE11AddDestinatarioW                                          : procedure ( p:LongInt; NumRegIdTrib:PChar; Nombre:PChar; Calle:PChar; NumeroExterior:PChar; NumeroInterior:PChar; Colonia:PChar; Localidad:PChar; Referencia:PChar; Municipio:PChar; Estado:PChar; Pais:PChar; CodigoPostal:PChar ); cdecl;
VirtualXML_CartaPorte10SetMercanciasTransporteFerrioviarioW               : procedure ( p:LongInt; TipoDeServicio:PChar; NombreAseg:PChar; NumPolizaSeguro:PChar; Concesionario:PChar; TipoDerechoDePaso:PChar; KilometrajePagado:PChar; TipoCarro:PChar; MatriculaCarro:PChar; GuiaCarro:PChar; ToneladasNetasCarro:PChar; TipoContenedor:PChar; PesoContenedorVacio:PChar; PesoNetoMercancia:PChar ); cdecl;
VirtualXML_SetComprobanteInfo_cfdi33W                                     : procedure ( p:LongInt; Serie:PChar; Folio:PChar; Fecha:PChar; FormaPago:PChar; CondicionesDePago:PChar; SubTotal:PChar; Descuento:PChar; Moneda:PChar; TipoCambio:PChar; Total:PChar; TipoDeComprobante:PChar; MetodoPago:PChar; LugarExpedicion:PChar;  Confirmacion:PChar ); cdecl;
VirtualXML_CartaPorte10AddFiguraTransportePropietarioW                    : procedure ( p:LongInt; RFCPropietario:PChar; NombrePropietario:PChar; NumRegIdTribPropietario:PChar; ResidenciaFiscalPropietario:PChar; Calle:PChar; NumeroExterior:PChar; NumeroInterior:PChar; Colonia:PChar; Localidad:PChar; Referencia:PChar; Municipio:PChar; Estado:PChar; Pais:PChar;  CodigoPostal:PChar ); cdecl;
VirtualXML_CartaPorte10AddFiguraTransporteArrendatarioW                   : procedure ( p:LongInt; RFCArrendatario:PChar; NombreArrendatario:PChar; NumRegIdTribArrendatario:PChar; ResidenciaFiscalArrendatario:PChar; Calle:PChar; NumeroExterior:PChar; NumeroInterior:PChar; Colonia:PChar; Localidad:PChar; Referencia:PChar; Municipio:PChar; Estado:PChar; Pais:PChar;  CodigoPostal:PChar ); cdecl;
VirtualXML_Pagos10SetPagoW                                                : procedure ( p:LongInt; FechaPago:PChar; FormaDePago:PChar; MonedaP:PChar; TipoCambioP:PChar; Monto:PChar; NumOperacion:PChar; RfcEmisorCtaOrd:PChar; NomBancoOrdExt:PChar; CtaOrdenante:PChar; RfcEmisorCtaBen:PChar; CtaBeneficiario:PChar; TipoCadPago:PChar; CertPago:PChar;  CadPago:PChar; SelloPago:PChar ); cdecl;
VirtualXML_CartaPorte10AddFiguraTransporteOperadoresW                     : procedure ( p:LongInt; RFCOperador:PChar; NumLicencia:PChar; NombreOperador:PChar; NumRegIdTribOperador:PChar; ResidenciaFiscalOperador:PChar; Calle:PChar; NumeroExterior:PChar; NumeroInterior:PChar; Colonia:PChar; Localidad:PChar; Referencia:PChar; Municipio:PChar; Estado:PChar; Pais:PChar;  CodigoPostal:PChar ); cdecl;
VirtualXML_CartaPorte10AddFiguraTransporteOperadoresOperadorW             : procedure ( p:LongInt; RFCOperador:PChar; NumLicencia:PChar; NombreOperador:PChar; NumRegIdTribOperador:PChar; ResidenciaFiscalOperador:PChar; Calle:PChar; NumeroExterior:PChar; NumeroInterior:PChar; Colonia:PChar; Localidad:PChar; Referencia:PChar; Municipio:PChar; Estado:PChar; Pais:PChar;  CodigoPostal:PChar ); cdecl;
VirtualXML_CartaPorte10SetMercanciasTransporteAereoW                      : procedure ( p:LongInt; PermSCT:PChar; NumPermisoSCT:PChar; MatriculaAeronave:PChar; NombreAseg:PChar; NumPolizaSeguro:PChar; NumeroGuia:PChar; LugarContrato:PChar; RFCTransportista:PChar; CodigoTransportista:PChar; NumRegIdTribTranspor:PChar; ResidenciaFiscalTranspor:PChar; NombreTransportista:PChar; RFCEmbarcador:PChar;  NumRegIdTribEmbarc:PChar;  ResidenciaFiscalEmbarc:PChar;  NombreEmbarcador:PChar ); cdecl;
VirtualXML_CartaPorte10SetMercanciasTransporteMaritimoW                   : procedure ( p:LongInt; PermSCT:PChar; NumPermisoSCT:PChar; NombreAseg:PChar; NumPolizaSeguro:PChar; TipoEmbarcacion:PChar; Matricula:PChar; NumeroOMI:PChar; AnioEmbarcacion:PChar; NombreEmbarc:PChar; NacionalidadEmbarc:PChar; UnidadesDeArqBruto:PChar; TipoCarga:PChar; NumCertITC:PChar;  Eslora            :PChar;  Manga                 :PChar;  Calado                 :PChar;  LineaNaviera              :PChar;  NombreAgenteNaviero  :PChar;  NumAutorizacionNaviero  :PChar;  NumViaje            :PChar;  NumConocEmbarc:PChar;  MatriculaContenedor:PChar;  TipoContenedor:PChar;  NumPrecinto:PChar); cdecl;
VirtualXML_CartaPorte10AddMercanciaW                                      : procedure ( p:LongInt; BienesTransp:PChar; ClaveSTCC:PChar; Descripcion:PChar; Cantidad:PChar; ClaveUnidad:PChar; Unidad:PChar; Dimensiones:PChar; MaterialPeligroso:PChar; CveMaterialPeligroso:PChar; Embalaje:PChar; DescripEmbalaje:PChar; PesoEnKg:PChar; ValorMercancia:PChar; Moneda:PChar;  FraccionArancelaria   :PChar;  UUIDComercioExt        :PChar;  CantidadTransportaCantidad:PChar;  IDOrigen             :PChar;  IDDestino               :PChar;  CvesTransporte      :PChar;  UnidadPeso	   :PChar;  PesoBruto          :PChar;  PesoNeto      :PChar;  PesoTara   :PChar;   NumPiezas:PChar); cdecl;
VirtualXML_CartaPorte10AddUbicacionW                                      : procedure ( p:LongInt; TipoEstacion:PChar; DistanciaRecorrida:PChar; IDOrigen:PChar; RFCRemitente:PChar; NombreRemitente:PChar; OrigenNumRegIdTrib:PChar; OrigenResidenciaFiscal:PChar; OrigenNumEstacion:PChar; OrigenNombreEstacion:PChar; OrigenNavegacionTrafico:PChar; FechaHoraSalida:PChar; IDDestino:PChar; RFCDestinatario:PChar;  NombreDestinatario:PChar;  DestinoNumRegIdTrib:PChar;  DestinoResidenciaFiscal:PChar;  DestinoNumEstacion        :PChar;  DestinoNombreEstacion:PChar;  DestinoNavegacionTrafico:PChar;  FechaHoraProgLlegada:PChar;  Calle         :PChar;  NumeroExterior     :PChar;  NumeroInterior:PChar;  Colonia    :PChar;   Localidad:PChar; Referencia:PChar; 	Municipio:PChar;  Estado:PChar;  Pais:PChar;  CodigoPostal:PChar ); cdecl;
}
